#include "stdafx.h"
#include <strsafe.h>
#include "resource.h"
#include "matrix32rtc.h"

extern TCHAR szTitle[];					// ^Cg o[̃eLXg

_mxINT32 UserCode = 1234;

void showErrorMsg(HWND hDlg, TCHAR* szMsg, short nResult)
{
	TCHAR szBuf[128];
	StringCchPrintf(szBuf, sizeof(szBuf), _T("%s : %d"), szMsg, nResult);
	MessageBox(hDlg, szBuf, szTitle, MB_OK | MB_ICONEXCLAMATION);
}

// nAreaẅ悪bNĂ邩ׂ
//  bNĂ   -> TRUE
//  bNĂȂ -> FALSE
BOOL IsAreaLocked(HWND hDlg, short nArea)
{
	_mxINT32 data[2];

	_mxINT16 nWriteResult;

	if (nArea == 1)
	{
		Dongle_ReadData(UserCode, data, 1, 1, 85);
		nWriteResult = Dongle_WriteData(UserCode, data, 1, 1, 85);
	}
	else if (nArea == 2)
	{
		Dongle_ReadData2(UserCode, (unsigned char*)data, 0, sizeof(_mxINT32) * 1, 1, 85);
		nWriteResult = Dongle_WriteData2(UserCode, (unsigned char*)data, 0, sizeof(_mxINT32)* 1, 1, 85);
	}

	if (nWriteResult == -9)
		return TRUE;

	return FALSE;
}

void startTimer(HWND hDlg, BOOL* pbTimerStarted)
{
	_mxINT16 nResult;

	if (1 == (nResult = Dongle_SetTimer(UserCode, 0, 1, 85)))
	{
		if (1 == (nResult = Dongle_StartTimer(UserCode, 1, 85)))
		{
			SetDlgItemText(hDlg, IDC_EDIT_INTERVAL, _T(""));
			*pbTimerStarted = TRUE;
		}
		else
		{
			showErrorMsg(hDlg, _T("Dongle_StartTimerG["), nResult);
		}
	}
	else
	{
		showErrorMsg(hDlg, _T("Dongle_SetTimerG["), nResult);
	}
}

void showTimer(HWND hDlg)
{
	_mxINT16 nResult;

	DWORD dwCount;
	if (1 == (nResult = Dongle_GetTimer(UserCode, &dwCount, 1, 85)))
	{
		TCHAR szTime[32];
		StringCchPrintf(szTime, 32, _T("%f"), dwCount*2.7 / 1000);
		SetDlgItemText(hDlg, IDC_EDIT_INTERVAL, szTime);
	}
	else
	{
		showErrorMsg(hDlg, _T("Dongle_GetTimerG["), nResult);
	}

}

void stopTimer(HWND hDlg, BOOL* pbTimerStarted)
{
	//^C}[JnĂȂ΁AȂŖ߂
	if (*pbTimerStarted == FALSE) return;

	_mxINT16 nResult;

	if (1 == (nResult = Dongle_StopTimer(UserCode, 1, 85)))
	{
		*pbTimerStarted = FALSE;
	}
	else
	{
		showErrorMsg(hDlg, _T("Dongle_StopTimerG["), nResult);
	}

}

void OnBtnLEDBlink(HWND hDlg, BOOL& bLEDBlinking)
{
	static BOOL bTimerStarted = FALSE;
	_mxINT16 nResult;

	if (bLEDBlinking == FALSE)
	{
		Init_MatrixAPI();

		if (Dongle_Count(85) == 0)
		{
			MessageBox(hDlg, _T("ELڑĂ"), szTitle, MB_OK | MB_ICONEXCLAMATION);
			Release_MatrixAPI();
			return;
		}

		if (1 == (nResult = Dongle_SetLED(5, 1, 85)) )
		{
			SetDlgItemText(hDlg, IDC_BTN_LEDBLINK, _T("LED"));
			bLEDBlinking = TRUE;

			//LED_ł^C}[Jn
			startTimer(hDlg, &bTimerStarted);
		}
		else
		{
			showErrorMsg(hDlg, _T("LED_ŃG["), nResult);
		}

	}
	else
	{
		if (1 == (nResult = Dongle_SetLED(0, 1, 85)))
		{
			bLEDBlinking = FALSE;
		}
		else
		{
			showErrorMsg(hDlg, _T("LEDG["), nResult);
		}

		// ^C}[JnĂ^C}[Ԃ\
		if (bTimerStarted == TRUE)
			showTimer(hDlg);

		stopTimer(hDlg, &bTimerStarted);

		Release_MatrixAPI();

		// Release_MatrixAPIŃ^C}[A_ł͎~܂邽
		// ㏈
		SetDlgItemText(hDlg, IDC_BTN_LEDBLINK, _T("LED_"));

		bTimerStarted = FALSE;
		bLEDBlinking = FALSE;

	}
}

void OnBtnSerNo(HWND hDlg)
{
	unsigned char szGUSN[24];

	_mxINT32 nSerNo = Dongle_ReadSerNr(UserCode, 1, 85);
	_mxINT16 nResult = Dongle_ReadGUSN(UserCode, szGUSN, 1, 85);
	_mxINT16 nMemSize = Dongle_MemSize(1, 85);
	_mxINT16 nMemSize2 = Dongle_MemSize2(1, 85);

	//
	// nSerNo, szGUSN, nMemSize, nMemSize2 𕶎ɂ
	// GfBbg{bNXɃZbg
	//
	char buf[32];

	StringCchPrintfA(buf, 32, "%ld", nSerNo);
	SetDlgItemTextA(hDlg, IDC_EDIT_SERNO, buf);

	StringCchPrintfA(buf, 32, "%d", nMemSize);
	SetDlgItemTextA(hDlg, IDC_EDIT_MEMSIZE1, buf);

	StringCchPrintfA(buf, 32, "%d", nMemSize2);
	SetDlgItemTextA(hDlg, IDC_EDIT_MEMSIZE2, buf);

	if (nResult == 1)
		SetDlgItemTextA(hDlg, IDC_EDIT_GUSN, (LPCSTR)szGUSN);
	else
		showErrorMsg(hDlg, _T("GUSN擾G["), nResult);
}

void OnBtnWriteData(HWND hDlg, short nArea)
{
	_mxINT32 data[16];
	TCHAR szBuf[16];

	// ݒ肳ĂtB[hf[^荞
	for (int i = 0; i < 15; i++)
	{
		GetDlgItemText(hDlg, IDC_EDIT_FIELD1 + i, szBuf, 16);
		if (_tcslen(szBuf) == 0)
			data[i] = 0;
		else
			data[i] = _tcstol(szBuf, NULL, 10);
	}

	_mxINT16 nResult;

	//̈Pւ̑
	if (nArea == 1)
	{
		nResult = Dongle_WriteData(UserCode, data, 15, 1, 85);
	}
	//̈Qւ̑
	else
	{
		nResult = Dongle_WriteData2(UserCode, (unsigned char*)data, 0, sizeof(_mxINT32)* 15, 1, 85);
	}

	if ((nArea == 1 && nResult == 15) || (nArea==2 && nResult==sizeof(_mxINT32)*15))
	{
		MessageBox(hDlg, _T("tB[hݐ!"), szTitle, MB_OK | MB_ICONINFORMATION);
	}
	else
	{
		showErrorMsg(hDlg, _T("tB[hG["), nResult);
	}
}

void OnBtnReadData(HWND hDlg, short nArea)
{
	_mxINT16 nResult;
	_mxINT32 data[16];
	TCHAR szBuf[16];

	//̈Pւ̑
	if (nArea == 1)
	{
		nResult = Dongle_ReadData(UserCode, data, 15, 1, 85);
	}
	//̈Qւ̑
	else
	{
		nResult = Dongle_ReadData2(UserCode, (unsigned char*)data, 0, sizeof(_mxINT32)* 15, 1, 85);
	}

	if ((nArea == 1 && nResult == 15) || (nArea == 2 && nResult == sizeof(_mxINT32)* 15))
	{
		//ǂݍ񂾃f[^tB[hɃZbg
		for (int i = 0; i < 15; i++)
		{
			StringCchPrintf(szBuf, 16, _T("%u"), data[i]);
			SetDlgItemText(hDlg, IDC_EDIT_FIELD1 + i, szBuf);
		}
	}
	else
	{
		showErrorMsg(hDlg, _T("tB[hǍG["), nResult);
	}
}

void OnChkAreaLocked(HWND hDlg, short nArea)
{
	_mxINT16 nResult;
	BOOL bLock;
	if (nArea == 1)
	{
		bLock = SendDlgItemMessage(hDlg, IDC_CHK_AREALOCKED1, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE;
		nResult = Dongle_LockData(UserCode, bLock, 12345, 1, 85);
	}
	else if (nArea == 2)
	{
		bLock = SendDlgItemMessage(hDlg, IDC_CHK_AREALOCKED2, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE;
		nResult = Dongle_LockData2(UserCode, bLock, 54321, 1, 85);
	}

	if ( nResult == 1)
		MessageBox(hDlg, _T("bN!"), szTitle, MB_OK | MB_ICONINFORMATION);
	else
		showErrorMsg(hDlg, _T("bNG["), nResult);

}

void OnBtnTeaWriteKey(HWND hDlg)
{
	_mxINT32 key[4];
	TCHAR szBuf[16];

	// ݒ肳ĂtB[hf[^荞
	for (int i = 0; i < 4; i++)
	{
		GetDlgItemText(hDlg, IDC_EDIT_TEAKEY1 + i, szBuf, 16);
		if (_tcslen(szBuf) == 0)
			key[i] = 0;
		else
			key[i] = _tcstol(szBuf, NULL, 10);
	}

	_mxINT16 nResult = Dongle_WriteKey(UserCode, key, 1, 85);
	if (nResult > 0)
		MessageBox(hDlg, _T("TEAÍݐ"), szTitle, MB_OK | MB_ICONINFORMATION);
	else
		showErrorMsg(hDlg, _T("TEAÍG["), nResult);
}

void OnBtnTeaEnc(HWND hDlg)
{
	_mxUINT32 data[2];
	TCHAR szBuf[16];

	GetDlgItemText(hDlg, IDC_EDIT_TEAPLAIN1, szBuf, 16);
	if (_tcslen(szBuf) == 0)
		data[0] = 0;
	else
		data[0] = _tcstoul(szBuf, NULL, 10);

	GetDlgItemText(hDlg, IDC_EDIT_TEAPLAIN2, szBuf, 16);
	if (_tcslen(szBuf) == 0)
		data[1] = 0;
	else
		data[1] = _tcstoul(szBuf, NULL, 10);

	_mxINT16 nResult = Dongle_EncryptData(UserCode, (_mxINT32*)data, 1, 85);

	if (nResult > 0)
	{
		StringCchPrintf(szBuf, sizeof(szBuf), _T("%u"), data[0]);
		SetDlgItemText(hDlg, IDC_EDIT_TEACIPHER1, szBuf);

		StringCchPrintf(szBuf, sizeof(szBuf), _T("%u"), data[1]);
		SetDlgItemText(hDlg, IDC_EDIT_TEACIPHER2, szBuf);
	}
	else
		showErrorMsg(hDlg, _T("TEAÍG["), nResult);
}

void OnBtnTeaDec(HWND hDlg)
{
	_mxUINT32 data[2];
	TCHAR szBuf[16];

	GetDlgItemText(hDlg, IDC_EDIT_TEACIPHER1, szBuf, 16);
	if (_tcslen(szBuf) == 0)
		data[0] = 0;
	else
		data[0] = _tcstoul(szBuf, NULL, 10);

	GetDlgItemText(hDlg, IDC_EDIT_TEACIPHER2, szBuf, 16);
	if (_tcslen(szBuf) == 0)
		data[1] = 0;
	else
		data[1] = _tcstoul(szBuf, NULL, 10);

	_mxINT16 nResult = Dongle_DecryptData(UserCode, (_mxINT32*)data, 1, 85);

	if (nResult > 0)
	{
		StringCchPrintf(szBuf, sizeof(szBuf), _T("%u"), data[0]);
		SetDlgItemText(hDlg, IDC_EDIT_TEAPLAIN1, szBuf);
		StringCchPrintf(szBuf, sizeof(szBuf), _T("%u"), data[1]);
		SetDlgItemText(hDlg, IDC_EDIT_TEAPLAIN2, szBuf);
	}
	else
		showErrorMsg(hDlg, _T("TEAG["), nResult);
}

BOOL NeedELInit(WORD controlID )
{
	// IDC_BTN_LEDBLINK ł Init_MatrixAPI, Releas_MatrixAPǏĂяo
	// g̏ōs   

	int nonELControlID[] = { IDC_BTN_LEDBLINK, IDOK, IDCANCEL };

	for (int i = 0; i < sizeof(nonELControlID); i++)
	{
		if (controlID == nonELControlID[i])
			return FALSE;
	}

	return TRUE;
}

void OnInitDlg(HWND hDlg)
{
	for (int i = 0; i < 15; i++)
		SendDlgItemMessage(hDlg, 151 + i, EM_LIMITTEXT, 10, 0);

	for (int i = 0; i < 4; i++)
		SendDlgItemMessage(hDlg, 1061 + i, EM_LIMITTEXT, 10, 0);

	SendDlgItemMessage(hDlg, IDC_EDIT_TEAPLAIN1, EM_LIMITTEXT, 10, 0);
	SendDlgItemMessage(hDlg, IDC_EDIT_TEAPLAIN2, EM_LIMITTEXT, 10, 0);
	SendDlgItemMessage(hDlg, IDC_EDIT_TEACIPHER1, EM_LIMITTEXT, 10, 0);
	SendDlgItemMessage(hDlg, IDC_EDIT_TEACIPHER2, EM_LIMITTEXT, 10, 0);

	Init_MatrixAPI();

	if (Dongle_Count(85) >  0)
	{
		if (IsAreaLocked(hDlg, 1) == TRUE)
			SendDlgItemMessage(hDlg, IDC_CHK_AREALOCKED1, BM_SETCHECK, TRUE, 0);
		if (IsAreaLocked(hDlg, 2) == TRUE)
			SendDlgItemMessage(hDlg, IDC_CHK_AREALOCKED2, BM_SETCHECK, TRUE, 0);
	}

	Release_MatrixAPI();

}

// Basic_CAÕbZ[W nh[łB
INT_PTR CALLBACK BasicDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	static BOOL bLEDBlinking = FALSE;

	switch (message)
	{
		case WM_INITDIALOG:
		{
		  OnInitDlg(hDlg);
		}
		return (INT_PTR)TRUE;

		case WM_COMMAND:
		{
			BOOL bRelease = FALSE;

	       //
		   // LED_Œ͏ȊȎ삪łȂ悤ɂ
		   // iRelease_MatrixAPIŃ^C}[~܂Ă܂)
		   //
		   if (bLEDBlinking == TRUE && LOWORD(wParam) != IDC_BTN_LEDBLINK) break;

		   if (NeedELInit(LOWORD(wParam)) )
		   {
			   Init_MatrixAPI();

			   if (Dongle_Count(85) == 0)
			   {
				   MessageBox(hDlg, _T("ELڑĂ"), szTitle, MB_OK | MB_ICONEXCLAMATION);
				   Release_MatrixAPI();
				   break;
			   }

			   bRelease = TRUE;
		   }

		   switch (LOWORD(wParam))
			{
				case IDC_BTN_LEDBLINK:
					OnBtnLEDBlink( hDlg, bLEDBlinking);
					break;

				case IDC_BTN_SERNO:
					OnBtnSerNo(hDlg);
					break;

				case IDC_CHK_AREALOCKED1:
					OnChkAreaLocked(hDlg, 1);
					break;

				case IDC_CHK_AREALOCKED2:
					OnChkAreaLocked(hDlg, 2);
					break;

				case IDC_BTN_READWRITE:
				{
					short nArea = -1;

					// Ï̊mF
					nArea = SendDlgItemMessage(hDlg, IDC_RADIO_AREA1, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : -1;
					if (nArea == -1)
						nArea = SendDlgItemMessage(hDlg, IDC_RADIO_AREA2, BM_GETCHECK, 0, 0) == BST_CHECKED ? 2 : -1;

					//̈悪IĂȂ
					if (nArea == -1)
					{
						MessageBox(hDlg, _T("Ώۗ̈IĂ"), szTitle, MB_OK | MB_ICONEXCLAMATION);
						break;
					}

					// SHIFTL[Ă珑
					if (GetAsyncKeyState(VK_SHIFT))
					{
						if (IDNO == MessageBox(hDlg, _T("tB[hf[^݂܂H"), szTitle, MB_YESNO | MB_ICONEXCLAMATION))
							break;
						OnBtnWriteData(hDlg, nArea);
					}
					else
						OnBtnReadData(hDlg, nArea);
				}
				break;

				case IDC_BTN_TEAWRITEKEY:
					OnBtnTeaWriteKey(hDlg);
					break;

				case IDC_BTN_TEAENC:
					OnBtnTeaEnc(hDlg);
					break;

				case IDC_BTN_TEADEC:
					OnBtnTeaDec(hDlg);
					break;

				case IDOK:
				case IDCANCEL:
				{
					EndDialog(hDlg, LOWORD(wParam));
					return (INT_PTR)TRUE;
				}
				break;
			}

		   if (bRelease)  Release_MatrixAPI();
		}
	}
	return (INT_PTR)FALSE;
}

