#include "stdafx.h"
#include <strsafe.h>
#include <wincrypt.h>
#include <time.h>
#include "resource.h"
#include "matrix32rtc.h"

extern TCHAR szTitle[];					// ^Cg o[̃eLXg
extern _mxINT32 UserCode;

BOOL NeedELInit(WORD controlID);

void showErrorMsg(HWND hDlg, TCHAR* szMsg, short nResult);

void OnBtnHMACSHA1WriteKey(HWND hDlg)
{
	char szBuf[36];
	GetDlgItemTextA(hDlg, IDC_EDIT_HMACKEY, szBuf, sizeof(szBuf));
	if (strlen(szBuf) != 25)
	{
		MessageBox(hDlg, _T("HMACSHA1̌25oCgŒł"), szTitle, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	_mxINT16 nResult = Dongle_WriteKeyHMACSHA1(UserCode, (unsigned char*)szBuf, 1, 85);
	if ( nResult > 0)
	{
		MessageBox(hDlg, _T("HMACSHA1̏ݐ"), szTitle, MB_OK | MB_ICONINFORMATION);
	}
	else
	{
		showErrorMsg(hDlg, _T("HMACSHA1̏݃G["), nResult);
	}
}

void OnBtnGetHMACSHA1(HWND hDlg)
{
	//nbV镶
	char* pBuf = new char[2048];
	_mxINT16 nBufLen = (_mxINT16)GetDlgItemTextA(hDlg, IDC_EDIT_HMACPLAIN, pBuf, 2048);

	// nbVl󂯎obt@
	char* pHash = new char[128];
	_mxINT16  nHashLen = 128;

	_mxINT16 nResult = Dongle_HMACSHA1(UserCode, pBuf, nBufLen, pHash, &nHashLen, 1, 85);

	delete pBuf;

	//G[
	if (nResult != 1)
	{
		delete pHash;
		showErrorMsg(hDlg, _T("HMACSHA1l擾G["), nResult);
		return;
	}

	DWORD dwDst = 0;
	LPSTR pstrDst = NULL;
	if (CryptBinaryToStringA((const BYTE*)pHash, nHashLen, CRYPT_STRING_BASE64, NULL, &dwDst))
	{
		pstrDst = new char[dwDst + 1];
		if (CryptBinaryToStringA((const BYTE*)pHash, nHashLen, CRYPT_STRING_BASE64, pstrDst, &dwDst))
		{
			SetDlgItemTextA(hDlg, IDC_EDIT_HMACHASH, pstrDst);
		}
	}
	delete pstrDst;
	delete pHash;

}

void OnBtnTDESWriteKey(HWND hDlg)
{
	char szBuf[36];
	_mxINT16  nBufLen = (_mxINT16)GetDlgItemTextA(hDlg, IDC_EDIT_TDESKEY, szBuf, sizeof(szBuf));
	if ( nBufLen != 16)
	{
		MessageBox(hDlg, _T("TDEŠ16oCgŒł"), szTitle, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	_mxINT16 nResult = Dongle_WriteKeyTDES(UserCode, (unsigned char*)szBuf, 1, 85);
	if (nResult > 0)
	{
		MessageBox(hDlg, _T("TDES̏ݐ"), szTitle, MB_OK | MB_ICONINFORMATION);
	}
	else
	{
		showErrorMsg(hDlg, _T("TDES̏݃G["), nResult);
	}

}

void OnBtnTDESEnc(HWND hDlg)
{
	char* pBuf    = new char[2048];
	_mxINT16   nBufLen = (_mxINT16)GetDlgItemTextA(hDlg, IDC_EDIT_TDESPLAIN, pBuf, 2048);

	char* pCipherText = new char[2048];
	_mxINT16 nCipherLen = 2048;

	// ̃Tvł͏xNg "12345678"@Œ
	_mxINT16 nResult = Dongle_EncryptDataTDES(UserCode, (unsigned char*)"12345678", pBuf, nBufLen, pCipherText, &nCipherLen, 1, 85);

	delete pBuf;

	if (nResult != 1)
	{
		delete pCipherText;
		showErrorMsg(hDlg, _T("TDESÍG["), nResult);
		return;
	}

	DWORD dwDst = 0;
	LPSTR pstrDst = NULL;
	if (CryptBinaryToStringA((const BYTE*)pCipherText, nCipherLen, CRYPT_STRING_BASE64, NULL, &dwDst))
	{
		pstrDst = new char[dwDst + 1];
		if (CryptBinaryToStringA((const BYTE*)pCipherText, nCipherLen, CRYPT_STRING_BASE64, pstrDst, &dwDst))
		{
			SetDlgItemTextA(hDlg, IDC_EDIT_TDESCIPHER, pstrDst);
		}
	}
	delete pstrDst;

	delete pCipherText;
}

void OnBtnTDESDec(HWND hDlg)
{
	char* pBuf = new char[2048];
	UINT nBufLen = GetDlgItemTextA(hDlg, IDC_EDIT_TDESCIPHER, pBuf, 2048);

	char* pPlainText = new char[2048];
	_mxINT16 nPlainLen = 2048;

	DWORD dwDst = 0;
	BYTE* pbDist = NULL;
	if (CryptStringToBinaryA(pBuf, nBufLen, CRYPT_STRING_BASE64, NULL, &dwDst, NULL, NULL))
	{
		pbDist = new BYTE[dwDst];
		if (CryptStringToBinaryA(pBuf, nBufLen, CRYPT_STRING_BASE64, pbDist, &dwDst, NULL, NULL))
		{
			//pbDist:oCg
			short nResult = Dongle_DecryptDataTDES(UserCode, (unsigned char*)"12345678", (char*)pbDist, (_mxINT16)dwDst,
				pPlainText, &nPlainLen, 1, 85);

			if (nResult == 1)
			{
				pPlainText[nPlainLen] = 0;
				SetDlgItemTextA(hDlg, IDC_EDIT_TDESPLAIN, pPlainText);
			}
			else
			{
				showErrorMsg(hDlg, _T("TDESÍG["), nResult);
			}
		}
	}

	delete pbDist;
	delete pPlainText;
	delete pBuf;

}

int RSAIndex(HWND hDlg)
{
	int index = SendDlgItemMessage(hDlg, IDC_RADIO_RSAKEYPAIR1, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
	if (index == 0)
		index = SendDlgItemMessage(hDlg, IDC_RADIO_RSAKEYPAIR2, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
	if (index == 0)
		index = SendDlgItemMessage(hDlg, IDC_RADIO_RSAKEYPAIR3, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
	if (index == 0)
	{
		MessageBox(hDlg, _T("ΏۃL[yAIĂ"), szTitle, MB_OK | MB_ICONEXCLAMATION);
		return 0;
	}

	return index;
}

void OnBtnRSACreateKeyPair(HWND hDlg)
{
	_mxINT16 index = (_mxINT16)RSAIndex(hDlg);
	if (index == 0) return;

	_mxINT16 nResult = Dongle_CreateRSAKeyPair(UserCode, index, 1, 85);
	if ( nResult == 1)
		MessageBox(hDlg, _T("RSAL[yA𐶐ď݂܂"), szTitle, MB_OK | MB_ICONINFORMATION);
	else
	{
		// Locked
		if (nResult == -9)
		{
			if ( index == 1)
				SendDlgItemMessage(hDlg, IDC_CHK_RSALOCKED1, BM_SETCHECK, 1, 0);
			else if (index == 2)
				SendDlgItemMessage(hDlg, IDC_CHK_RSALOCKED2, BM_SETCHECK, 1, 0);
			else if (index == 3)
				SendDlgItemMessage(hDlg, IDC_CHK_RSALOCKED3, BM_SETCHECK, 1, 0);
		}

		showErrorMsg(hDlg, _T("RSAL[yAG["), nResult);
	}
}

void OnChkRSALocked(HWND hDlg, int index)
{
	BOOL bLock;
	if (index == 1)
	{
		bLock = SendDlgItemMessage(hDlg, IDC_CHK_RSALOCKED1, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE;
	}
	else if (index == 2)
	{
		bLock = SendDlgItemMessage(hDlg, IDC_CHK_RSALOCKED2, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE;
	}
	else if (index == 3)
	{
		bLock = SendDlgItemMessage(hDlg, IDC_CHK_RSALOCKED2, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE;
	}
	else
		return;

	_mxINT16 nResult = Dongle_LockRSAKeyPair(UserCode, index, bLock, 12345, 1, 85);
	if (nResult != 1)
	{
		showErrorMsg(hDlg, _T("RSAL[yÃbNG["), nResult);
	}
}

void OnBtnRSAEnc(HWND hDlg)
{
	_mxINT16 index = (_mxINT16)RSAIndex(hDlg);
	if (index == 0) return;

	char* pBuf = new char[128];
	_mxINT16   nBufLen = (_mxINT16)GetDlgItemTextA(hDlg, IDC_EDIT_RSAPLAIN, pBuf, 128);

	char* pCipherText = new char[2048];
	_mxINT16 nCipherLen = 2048;

	_mxINT16 nResult = Dongle_EncryptDataRSA(UserCode, index, (unsigned char*)pBuf, nBufLen, 
							(unsigned char*)pCipherText, &nCipherLen, 1, 85);

	delete pBuf;

	if (nResult != 1)
	{
		delete pCipherText;
		showErrorMsg(hDlg, _T("RSAÍG["), nResult);
		return;
	}

	DWORD dwDst = 0;
	LPSTR pstrDst = NULL;
	if (CryptBinaryToStringA((const BYTE*)pCipherText, nCipherLen, CRYPT_STRING_BASE64, NULL, &dwDst))
	{
		pstrDst = new char[dwDst + 1];
		if (CryptBinaryToStringA((const BYTE*)pCipherText, nCipherLen, CRYPT_STRING_BASE64, pstrDst, &dwDst))
		{
			SetDlgItemTextA(hDlg, IDC_EDIT_RSACIPHER, pstrDst);
		}
	}
	delete pstrDst;

	delete pCipherText;

}

void OnBtnRSADec(HWND hDlg)
{
	_mxINT16 index = (_mxINT16)RSAIndex(hDlg);
	if (index == 0) return;

	char* pBuf = new char[2048];
	UINT nBufLen = GetDlgItemTextA(hDlg, IDC_EDIT_RSACIPHER, pBuf, 2048);

	char* pPlainText = new char[128];
	_mxINT16 nPlainLen = 128;

	DWORD dwDst = 0;
	BYTE* pbDist = NULL;
	if (CryptStringToBinaryA(pBuf, nBufLen, CRYPT_STRING_BASE64, NULL, &dwDst, NULL, NULL))
	{
		pbDist = new BYTE[dwDst];
		if (CryptStringToBinaryA(pBuf, nBufLen, CRYPT_STRING_BASE64, pbDist, &dwDst, NULL, NULL))
		{
			//pbDist:oCg
			short nResult = Dongle_DecryptDataRSA(UserCode, index, (unsigned char*)pbDist, (_mxINT16)dwDst,
								(unsigned char*)pPlainText, &nPlainLen, 1, 85);

			if (nResult == 1)
			{
				pPlainText[nPlainLen] = 0;
				SetDlgItemTextA(hDlg, IDC_EDIT_RSAPLAIN, pPlainText);
			}
			else
				showErrorMsg(hDlg, _T("RSAG["), nResult);
		}
	}

	delete pbDist;
	delete pPlainText;
	delete pBuf;


}

void OnBtnRTC(HWND hDlg)
{
	_mxUINT32 nTime;

	_mxINT16 nResult = Dongle_GetTime(UserCode, &nTime, 1, 85);

	if (nResult == 1)
	{
		char szBuf[64];
		time_t t = nTime;

		tm timer;
		gmtime_s(&timer, &t);
		asctime_s(szBuf, sizeof(szBuf), &timer);

		StringCchCatA(szBuf, 64, " UTC");
		SetDlgItemTextA(hDlg, IDC_EDIT_RTC, szBuf);
	}
	else
	{
		showErrorMsg(hDlg, _T("A^CNbNԎ擾G["), nResult);
	}

}

// g_CAÕbZ[W nh[łB
INT_PTR CALLBACK ExtendedDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
		case WM_INITDIALOG:
			SendDlgItemMessage(hDlg, IDC_EDIT_HMACKEY, EM_LIMITTEXT, 25, 0);
			SendDlgItemMessage(hDlg, IDC_EDIT_TDESKEY, EM_LIMITTEXT, 16, 0);
			SendDlgItemMessage(hDlg, IDC_EDIT_RSAPLAIN, EM_LIMITTEXT, 128, 0);
			return (INT_PTR)TRUE;

		case WM_COMMAND:
		{
			BOOL bRelease = FALSE;

			if (NeedELInit(LOWORD(wParam)))
			{
				Init_MatrixAPI();

				if (Dongle_Count(85) == 0)
				{
					MessageBox(hDlg, _T("ELڑĂ"), szTitle, MB_OK | MB_ICONEXCLAMATION);
					Release_MatrixAPI();
					break;
				}

				bRelease = TRUE;
			}

		    switch (LOWORD(wParam))
			{
				case IDC_BTN_HMACWRITEKEY:
					OnBtnHMACSHA1WriteKey(hDlg);
				break;

				case IDC_BTN_GETHMACSHA1:
					OnBtnGetHMACSHA1(hDlg);
				break;

				case IDC_BTN_TDESWRITEKEY:
					OnBtnTDESWriteKey(hDlg);
				break;

				case IDC_BTN_TDESENC:
					OnBtnTDESEnc(hDlg);
				break;

				case IDC_BTN_TDESDEC:
					OnBtnTDESDec(hDlg);
				break;

				case IDC_BTN_RSACREATEKEYPAIR:
					OnBtnRSACreateKeyPair(hDlg);
				break;

				case IDC_CHK_RSALOCKED1:
					OnChkRSALocked(hDlg, 1);
					break;

				case IDC_CHK_RSALOCKED2:
					OnChkRSALocked(hDlg, 2);
					break;

				case IDC_CHK_RSALOCKED3:
					OnChkRSALocked(hDlg, 3);
					break;

				case IDC_BTN_RSAENC:
					OnBtnRSAEnc(hDlg);
					break;

				case IDC_BTN_RSADEC:
					OnBtnRSADec(hDlg);
					break;

				case IDC_BTN_RTC:
					OnBtnRTC(hDlg);
					break;

				case IDOK:
				case IDCANCEL:
				{
					EndDialog(hDlg, LOWORD(wParam));
					return (INT_PTR)TRUE;
				}
				break;
			}

			if (bRelease)  Release_MatrixAPI();

		}
	}
	return (INT_PTR)FALSE;
}

